// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{Bin, TabStyle};
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

#[cfg(feature = "gtk_v3_4")]
#[cfg_attr(docsrs, doc(cfg(feature = "gtk_v3_4")))]
glib::wrapper! {
    #[doc(alias = "DzlTab")]
    pub struct Tab(Object<ffi::DzlTab, ffi::DzlTabClass>) @extends Bin, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable, gtk::Actionable;

    match fn {
        type_ => || ffi::dzl_tab_get_type(),
    }
}

#[cfg(not(any(feature = "gtk_v3_4")))]
glib::wrapper! {
    #[doc(alias = "DzlTab")]
    pub struct Tab(Object<ffi::DzlTab, ffi::DzlTabClass>) @extends Bin, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_tab_get_type(),
    }
}

impl Tab {
    #[doc(alias = "dzl_tab_get_active")]
    #[doc(alias = "get_active")]
    pub fn is_active(&self) -> bool {
        unsafe { from_glib(ffi::dzl_tab_get_active(self.to_glib_none().0)) }
    }

    #[doc(alias = "dzl_tab_get_can_close")]
    #[doc(alias = "get_can_close")]
    pub fn can_close(&self) -> bool {
        unsafe { from_glib(ffi::dzl_tab_get_can_close(self.to_glib_none().0)) }
    }

    #[doc(alias = "dzl_tab_get_edge")]
    #[doc(alias = "get_edge")]
    pub fn edge(&self) -> gtk::PositionType {
        unsafe { from_glib(ffi::dzl_tab_get_edge(self.to_glib_none().0)) }
    }

    #[doc(alias = "dzl_tab_get_icon_name")]
    #[doc(alias = "get_icon_name")]
    pub fn icon_name(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::dzl_tab_get_icon_name(self.to_glib_none().0)) }
    }

    #[doc(alias = "dzl_tab_get_style")]
    #[doc(alias = "get_style")]
    pub fn style(&self) -> TabStyle {
        unsafe { from_glib(ffi::dzl_tab_get_style(self.to_glib_none().0)) }
    }

    #[doc(alias = "dzl_tab_get_title")]
    #[doc(alias = "get_title")]
    pub fn title(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::dzl_tab_get_title(self.to_glib_none().0)) }
    }

    #[doc(alias = "dzl_tab_get_widget")]
    #[doc(alias = "get_widget")]
    pub fn widget(&self) -> Option<gtk::Widget> {
        unsafe { from_glib_none(ffi::dzl_tab_get_widget(self.to_glib_none().0)) }
    }

    #[doc(alias = "dzl_tab_set_active")]
    pub fn set_active(&self, active: bool) {
        unsafe {
            ffi::dzl_tab_set_active(self.to_glib_none().0, active.into_glib());
        }
    }

    #[doc(alias = "dzl_tab_set_can_close")]
    pub fn set_can_close(&self, can_close: bool) {
        unsafe {
            ffi::dzl_tab_set_can_close(self.to_glib_none().0, can_close.into_glib());
        }
    }

    #[doc(alias = "dzl_tab_set_edge")]
    pub fn set_edge(&self, edge: gtk::PositionType) {
        unsafe {
            ffi::dzl_tab_set_edge(self.to_glib_none().0, edge.into_glib());
        }
    }

    #[doc(alias = "dzl_tab_set_gicon")]
    pub fn set_gicon(&self, gicon: &impl IsA<gio::Icon>) {
        unsafe {
            ffi::dzl_tab_set_gicon(self.to_glib_none().0, gicon.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_tab_set_icon_name")]
    pub fn set_icon_name(&self, icon_name: &str) {
        unsafe {
            ffi::dzl_tab_set_icon_name(self.to_glib_none().0, icon_name.to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_tab_set_style")]
    pub fn set_style(&self, style: TabStyle) {
        unsafe {
            ffi::dzl_tab_set_style(self.to_glib_none().0, style.into_glib());
        }
    }

    #[doc(alias = "dzl_tab_set_title")]
    pub fn set_title(&self, title: &str) {
        unsafe {
            ffi::dzl_tab_set_title(self.to_glib_none().0, title.to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_tab_set_widget")]
    pub fn set_widget(&self, widget: &impl IsA<gtk::Widget>) {
        unsafe {
            ffi::dzl_tab_set_widget(self.to_glib_none().0, widget.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "clicked")]
    pub fn connect_clicked<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn clicked_trampoline<F: Fn(&Tab) + 'static>(
            this: *mut ffi::DzlTab,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"clicked\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    clicked_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "active")]
    pub fn connect_active_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_active_trampoline<F: Fn(&Tab) + 'static>(
            this: *mut ffi::DzlTab,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::active\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_active_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "can-close")]
    pub fn connect_can_close_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_can_close_trampoline<F: Fn(&Tab) + 'static>(
            this: *mut ffi::DzlTab,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::can-close\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_can_close_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "edge")]
    pub fn connect_edge_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_edge_trampoline<F: Fn(&Tab) + 'static>(
            this: *mut ffi::DzlTab,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::edge\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_edge_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "style")]
    pub fn connect_style_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_style_trampoline<F: Fn(&Tab) + 'static>(
            this: *mut ffi::DzlTab,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::style\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_style_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "title")]
    pub fn connect_title_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_title_trampoline<F: Fn(&Tab) + 'static>(
            this: *mut ffi::DzlTab,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::title\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_title_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "widget")]
    pub fn connect_widget_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_widget_trampoline<F: Fn(&Tab) + 'static>(
            this: *mut ffi::DzlTab,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::widget\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_widget_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl fmt::Display for Tab {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("Tab")
    }
}
